/* Copyright (c) 2002 Petr Bilek
   Tento kod je volne programove vybaveni; muzete jej sirit a modifikovat
podle ustanoveni Obecne verejne license GNU, vydavane FreeSoftware Foundation.
Na tento program se nevztahuji ZADNE ZARUKY; neposkytuji se ani odvozene zaruky
PRODEJNSTI anebo VHODNOSTI PRO URCITY UCEL. */
/* soubor curses2.c */

#include "curses2.h"
#include <stdarg.h>
#include <semaphore.h>

sem_t semafor;
sem_t semafor_cteni;
int navrat;


int
curses_semafor_init (void)
{
  return (sem_init (&semafor, 0, 1) || sem_init (&semafor_cteni, 0, 1));
}

int
curses_semafor_destroy (void)
{
  return (sem_destroy (&semafor) || sem_destroy (&semafor_cteni));
}

int
curses_wait (int test)
{

  if (test == 1)
    {
      return sem_wait (&semafor);
    }
  else
    {
      return sem_post (&semafor);
    }
}

int
curses_wait_cteni (int test)
{

  if (test == 1)
    {
      return sem_wait (&semafor_cteni);
    }
  else
    {
      return sem_post (&semafor_cteni);
    }
}

/**initscr**/
WINDOW *
initscr2 (void)
{
  return initscr ();
}

/**clearok**/
int
clearok2 (WINDOW * win, bool bf)
{
  while (curses_wait (1));
  navrat = clearok (win, bf);
  curses_wait (0);
  return navrat;
}

/**endwin**/
int
endwin2 (void)
{
  while (curses_wait (1));
  navrat = endwin ();
  curses_wait (0);
  return navrat;
}

/**addch**/
int
addch2 (const chtype znak)
{
  while (curses_wait (1));
  navrat = addch (znak);
  curses_wait (0);
  return navrat;
}

int
waddch2 (WINDOW * window_ptr, const chtype znak)
{
  while (curses_wait (1));
  navrat = waddch (window_ptr, znak);
  curses_wait (0);
  return navrat;
}

int
mvaddch2 (int y, int x, const chtype znak)
{
  while (curses_wait (1));
  navrat = mvaddch (y, x, znak);
  curses_wait (0);
  return navrat;
}

int
mvwaddch2 (WINDOW * window_ptr, int y, int x, const chtype znak)
{
  while (curses_wait (1));
  navrat = mvwaddch (window_ptr, y, x, znak);
  curses_wait (0);
  return navrat;
}

/**addchstr**/
int
addchstr2 (chtype * const string)
{
  while (curses_wait (1));
  navrat = addchstr (string);
  curses_wait (0);
  return navrat;
}

int
waddchstr2 (WINDOW * window_ptr, chtype * const string)
{
  while (curses_wait (1));
  navrat = waddchstr (window_ptr, string);
  curses_wait (0);
  return navrat;
}

int
mvaddchstr2 (int y, int x, chtype * const string)
{
  while (curses_wait (1));
  navrat = mvaddchstr (y, x, string);
  curses_wait (0);
  return navrat;
}

int
mvwaddchstr2 (WINDOW * window_ptr, int y, int x, chtype * const string)
{
  while (curses_wait (1));
  navrat = mvwaddchstr (window_ptr, y, x, string);
  curses_wait (0);
  return navrat;
}

/**printw**/
int
printw2 (char *string)
{
  while (curses_wait (1));
  navrat = printw ("%s", string);
  curses_wait (0);
  return navrat;
}

int
wprintw2 (WINDOW * window_ptr, char *string)
{
  while (curses_wait (1));
  navrat = wprintw (window_ptr, "%s", string);
  curses_wait (0);
  return navrat;
}

int
mvprintw2 (int y, int x, char *string)
{
  while (curses_wait (1));
  navrat = mvprintw (y, x, "%s", string);
  curses_wait (0);
  return navrat;
}

int
mvwprintw2 (WINDOW * window_ptr, int y, int x, char *string)
{
  while (curses_wait (1));
  navrat = mvwprintw (window_ptr, y, x, "%s", string);
  curses_wait (0);
  return navrat;
}

/**refresh**/
int
redrawwin2 (WINDOW * win)
{
  while (curses_wait (1));
  navrat = redrawwin (win);
  curses_wait (0);
  return navrat;
}


int
refresh2 (void)
{
  while (curses_wait (1));
  navrat = refresh ();
  curses_wait (0);
  return navrat;
}

int
wrefresh2 (WINDOW * window_ptr)
{
  while (curses_wait (1));
  navrat = wrefresh (window_ptr);
  curses_wait (0);
  return navrat;
}

/**box***/
int
box2 (WINDOW * window_ptr, chtype vertical, chtype horizontal)
{
  while (curses_wait (1));
  navrat = box (window_ptr, vertical, horizontal);
  curses_wait (0);
  return navrat;
}

int
wborder2 (WINDOW * win, chtype ls, chtype rs, chtype ts, chtype bs,
	  chtype tl, chtype tr, chtype bl, chtype br)
{
  while (curses_wait (1));
  navrat = wborder (win, ls, rs, ts, bs, tl, tr, bl, br);
  curses_wait (0);
  return navrat;
}

/**insh**/
int
insch2 (chtype znak)
{
  while (curses_wait (1));
  navrat = insch (znak);
  curses_wait (0);
  return navrat;
}

int
winsch2 (WINDOW * window_ptr, chtype znak)
{
  while (curses_wait (1));
  navrat = winsch (window_ptr, znak);
  curses_wait (0);
  return navrat;
}

int
mvinsch2 (int y, int x, chtype znak)
{
  while (curses_wait (1));
  navrat = mvinsch (y, x, znak);
  curses_wait (0);
  return navrat;
}

int
mvwinsch2 (WINDOW * window_ptr, int y, int x, chtype znak)
{
  while (curses_wait (1));
  navrat = mvwinsch (window_ptr, y, x, znak);
  curses_wait (0);
  return navrat;
}

/**insertln**/
int
insertln2 (void)
{
  while (curses_wait (1));
  navrat = insertln ();
  curses_wait (0);
  return navrat;
}

/**delch**/
int
delch2 (void)
{
  while (curses_wait (1));
  navrat = delch ();
  curses_wait (0);
  return navrat;
}

/**deleteln**/
int
deleteln2 (void)
{
  while (curses_wait (1));
  navrat = deleteln ();
  curses_wait (0);
  return navrat;
}

/**beep**/
int
beep2 (void)
{
  while (curses_wait (1));
  navrat = beep ();
  curses_wait (0);
  return navrat;
}

/**flash**/
int
flash2 (void)
{
  while (curses_wait (1));
  navrat = flash ();
  curses_wait (0);
  return navrat;
}

/**inch**/
chtype
inch2 (void)
{
  chtype navrat;
  while (curses_wait (1));
  navrat = inch ();
  curses_wait (0);
  return navrat;
}

chtype
winch2 (WINDOW * win)
{
  chtype navrat;
  while (curses_wait (1));
  navrat = winch (win);
  curses_wait (0);
  return navrat;
}

chtype
mvinch2 (int x, int y)
{
  chtype navrat;
  while (curses_wait (1));
  navrat = mvinch (x, y);
  curses_wait (0);
  return navrat;
}

chtype
mvwinch2 (WINDOW * win, int x, int y)
{
  chtype navrat;
  while (curses_wait (1));
  navrat = mvwinch (win, x, y);
  curses_wait (0);
  return navrat;
}

/**instr**/
int
instr2 (char *string)
{
  while (curses_wait (1));
  navrat = instr (string);
  curses_wait (0);
  return navrat;
}

/**innstr**/
int
innstr2 (char *string, int number_of_characters)
{
  while (curses_wait (1));
  navrat = innstr (string, number_of_characters);
  curses_wait (0);
  return navrat;
}

/**erase**/
int
erase2 (void)
{
  while (curses_wait (1));
  navrat = erase ();
  curses_wait (0);
  return navrat;
}

int
werase2 (WINDOW * window_ptr)
{
  while (curses_wait (1));
  navrat = werase (window_ptr);
  curses_wait (0);
  return navrat;
}

/**clear**/
int
clear2 (void)
{
  while (curses_wait (1));
  navrat = clear ();
  curses_wait (0);
  return navrat;
}

int
wclear2 (WINDOW * window_ptr)
{
  while (curses_wait (1));
  navrat = wclear (window_ptr);
  curses_wait (0);
  return navrat;
}

/**clrtobot**/
int
clrtobot2 (void)
{
  while (curses_wait (1));
  navrat = clrtobot ();
  curses_wait (0);
  return navrat;
}

int
wclrtobot2 (WINDOW * window_ptr)
{
  while (curses_wait (1));
  navrat = wclrtobot (window_ptr);
  curses_wait (0);
  return navrat;
}

/**move**/
int
move2 (int y, int x)
{
  while (curses_wait (1));
  navrat = move (y, x);
  curses_wait (0);
  return navrat;
}

int
wmove2 (WINDOW * window_ptr, int y, int x)
{
  while (curses_wait (1));
  navrat = wmove (window_ptr, y, x);
  curses_wait (0);
  return navrat;
}

/**leaveok**/
int
leaveok2 (WINDOW * window_ptr, bool flag)
{
  while (curses_wait (1));
  navrat = leaveok (window_ptr, flag);
  curses_wait (0);
  return navrat;
}

/**attron**/
int
attron2 (chtype attribute)
{
  while (curses_wait (1));
  navrat = attron (attribute);
  curses_wait (0);
  return navrat;
}

int
wattron2 (WINDOW * window_ptr, chtype attribute)
{
  while (curses_wait (1));
  navrat = wattron (window_ptr, attribute);
  curses_wait (0);
  return navrat;
}

/**attroff**/
int
attroff2 (chtype attribute)
{
  while (curses_wait (1));
  navrat = attroff (attribute);
  curses_wait (0);
  return navrat;
}

int
wattroff2 (WINDOW * window_ptr, chtype attribute)
{
  while (curses_wait (1));
  navrat = wattroff (window_ptr, attribute);
  curses_wait (0);
  return navrat;
}

/**attrset**/

int
attrset2 (chtype attribute)
{
  while (curses_wait (1));
  navrat = attrset (attribute);
  curses_wait (0);
  return navrat;
}

int
wattrset2 (WINDOW * window_ptr, chtype attribute)
{
  while (curses_wait (1));
  navrat = wattrset (window_ptr, attribute);
  curses_wait (0);
  return navrat;
}

/**standout**/
int
standout2 (void)
{
  while (curses_wait (1));
  navrat = standout ();
  curses_wait (0);
  return navrat;
}

int
wstandout2 (WINDOW * window_ptr)
{
  while (curses_wait (1));
  navrat = wstandout (window_ptr);
  curses_wait (0);
  return navrat;
}

/**standend**/
int
standend2 (void)
{
  while (curses_wait (1));
  navrat = standend ();
  curses_wait (0);
  return navrat;
}

int
wstandend2 (WINDOW * window_ptr)
{
  while (curses_wait (1));
  navrat = wstandend (window_ptr);
  curses_wait (0);
  return navrat;
}

/**echo**/
int
echo2 (void)
{
  while (curses_wait (1));
  navrat = echo ();
  curses_wait (0);
  return navrat;
}

/**noecho**/
int
noecho2 (void)
{
  while (curses_wait (1));
  navrat = noecho ();
  curses_wait (0);
  return navrat;
}

/**halfdelay**/
int
halfdelay2 (int tenths)
{
  while (curses_wait (1));
  navrat = halfdelay (tenths);
  curses_wait (0);
  return navrat;
}

/**cbreak**/
int
cbreak2 (void)
{
  while (curses_wait (1));
  navrat = cbreak ();
  curses_wait (0);
  return navrat;
}

/**nocbreak**/
int
nocbreak2 (void)
{
  while (curses_wait (1));
  navrat = nocbreak ();
  curses_wait (0);
  return navrat;
}

/**raw**/
int
raw2 (void)
{
  while (curses_wait (1));
  navrat = raw ();
  curses_wait (0);
  return navrat;
}

/**noraw**/
int
noraw2 (void)
{
  while (curses_wait (1));
  navrat = noraw ();
  curses_wait (0);
  return navrat;
}

/**getch**/
int
getch2 (void)
{
  /* while (curses_wait_cteni(1)); */
  navrat = getch ();
  /* curses_wait_cteni(0); */
  return navrat;
}

/**wgetch**/
int
wgetch2 (WINDOW * win_ptr)
{
  /* while (curses_wait_cteni(1)); */
  navrat = wgetch (win_ptr);
  /* curses_wait_cteni(0); */
  return navrat;
}

/**getstr**/
int
getstr2 (char *string)
{
  while (curses_wait_cteni (1));
  navrat = getstr (string);
  curses_wait_cteni (0);
  return navrat;
}

/**getnstr**/
int
getnstr2 (char *string, int number_of_characters)
{
  while (curses_wait_cteni (1));
  navrat = getnstr (string, number_of_characters);
  curses_wait_cteni (0);
  return navrat;
}

/**wgetnstr**/
int
wgetnstr2 (WINDOW * win, char *str, int n)
{
  while (curses_wait_cteni (1));
  navrat = wgetnstr (win, str, n);
  curses_wait_cteni (0);
  return navrat;
}

/**newwin**/
WINDOW *
newwin2 (int lines, int cols, int y, int x)
{
  WINDOW *navrat;
  while (curses_wait (1));
  navrat = newwin (lines, cols, y, x);
  curses_wait (0);
  return navrat;
}

/**delwin**/
int
delwin2 (WINDOW * window_ptr)
{
  while (curses_wait (1));
  navrat = delwin (window_ptr);
  curses_wait (0);
  return navrat;
}

/**mvwin**/
int
mvwin2 (WINDOW * window_ptr, int y, int x)
{
  while (curses_wait (1));
  navrat = mvwin (window_ptr, y, x);
  curses_wait (0);
  return navrat;
}

/**touchwin**/
int
touchwin2 (WINDOW * window_ptr)
{
  while (curses_wait (1));
  navrat = touchwin (window_ptr);
  curses_wait (0);
  return navrat;
}

/**scrollok**/
int
scrollok2 (WINDOW * window_ptr, bool scroll_flag)
{
  while (curses_wait (1));
  navrat = scrollok (window_ptr, scroll_flag);
  curses_wait (0);
  return navrat;
}

/**scroll**/
int
scroll2 (WINDOW * window_ptr)
{
  while (curses_wait (1));
  navrat = scroll (window_ptr);
  curses_wait (0);
  return navrat;
}

/**wnoutrefresh**/
int
wnoutrefresh2 (WINDOW * window_ptr)
{
  while (curses_wait (1));
  navrat = wnoutrefresh (window_ptr);
  curses_wait (0);
  return navrat;
}


/**doupdate**/
int
doupdate2 (void)
{
  while (curses_wait (1));
  navrat = doupdate ();
  curses_wait (0);
  return navrat;
}


/**subwin**/
WINDOW *
subwin2 (WINDOW * window_ptr, int lines, int cols, int y, int x)
{
  WINDOW *navrat;
  while (curses_wait (1));
  navrat = subwin (window_ptr, lines, cols, y, x);
  curses_wait (0);
  return navrat;
}

/**keypad**/
int
keypad2 (WINDOW * window_ptr, bool keypad_on)
{
  while (curses_wait (1));
  navrat = keypad (window_ptr, keypad_on);
  curses_wait (0);
  return navrat;
}

/**has_colors**/
bool
has_colors2 (void)
{
  bool navrat;
  while (curses_wait (1));
  navrat = has_colors ();
  curses_wait (0);
  return navrat;
}

/**start_color**/
int
start_color2 (void)
{
  int navrat;
  while (curses_wait (1));
  navrat = start_color ();
  curses_wait (0);
  return navrat;
}

int
use_default_colors2 (void)
{
  int navrat;
  while (curses_wait (1));
  navrat = use_default_colors ();
  curses_wait (0);
  return navrat;
}

/**init_pair**/
int
init_pair2 (short pair_number, short foreground, short background)
{
  while (curses_wait (1));
  navrat = init_pair (pair_number, foreground, background);
  curses_wait (0);
  return navrat;
}

/**COLOR_PAIR**/
int
COLOR_PAIR2 (int pair_number)
{
  while (curses_wait (1));
  navrat = COLOR_PAIR (pair_number);
  curses_wait (0);
  return navrat;
}

/**pair_content**/
int
pair_content2 (short pair_number, short *foreground, short *background)
{
  while (curses_wait (1));
  navrat = pair_content (pair_number, foreground, background);
  curses_wait (0);
  return navrat;
}

/**init_color**/
int
init_color2 (short number, short red, short green, short blue)
{
  while (curses_wait (1));
  navrat = init_color (number, red, green, blue);
  curses_wait (0);
  return navrat;
}

/**newpad**/
WINDOW *
newpad2 (int lines, int cols)
{
  WINDOW *navrat;
  while (curses_wait (1));
  navrat = newpad (lines, cols);
  curses_wait (0);
  return navrat;
}

/**prefresh**/
int
prefresh2 (WINDOW * win_ptr, int pad_row, int pad_cols,
	   int screen_row_min, int screen_col_min,
	   int screen_row_max, int screen_col_max)
{
  while (curses_wait (1));
  navrat = prefresh (win_ptr, pad_row, pad_cols, screen_row_min,
		     screen_col_min, screen_row_max, screen_col_max);
  curses_wait (0);
  return navrat;
}

/**pnoutrefresh**/
int
pnoutrefresh2 (WINDOW * win_ptr, int pad_row, int pad_cols,
	       int screen_row_min, int screen_col_min,
	       int screen_row_max, int screen_col_max)
{
  while (curses_wait (1));
  navrat = pnoutrefresh (win_ptr, pad_row, pad_cols, screen_row_min,
			 screen_col_min, screen_row_max, screen_col_max);
  curses_wait (0);
  return navrat;
}
