#include <stdio.h>
#include <string.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include "get-ip-address.h"

char *
getIpAddress (const char *const dns, bool print_warning)
{
  struct hostent *server;
  struct in_addr addr;

  server = gethostbyname (dns);
  if (!server)
    {
      if (print_warning)
	fprintf (stderr, "Nebyl nalezen server www.sallyx.og\n");
      return NULL;
    }
  memset (&addr, 0, sizeof (addr));
  memcpy (&(addr.s_addr), server->h_addr_list[0], sizeof (addr.s_addr));
  return inet_ntoa (addr);
}
