/* Copyright (c) 2002 Petr Bilek
   Tento kod je volne programove vybaveni; muzete jej sirit a modifikovat
podle ustanoveni Obecne verejne license GNU, vydavane FreeSoftware Foundation.
Na tento program se nevztahuji ZADNE ZARUKY; neposkytuji se ani odvozene zaruky
PRODEJNSTI anebo VHODNOSTI PRO URCITY UCEL. */
/* soubor spust_nov_text.c */

#include <limits.h>
#include <string.h>
#include <errno.h>
#include "strukturyw.h"
#include "struktury.h"
#include "libw.h"
#include "lib.h"
#include "profi/spust-nov-text-c-include.h"

static FILE *soubor_vt;
static char radek_vt[RADEK];


int
inicializuj_nov_text (type_odstavec * odstavec, char *nov_text)
{
  char jmeno_l[NAME_MAX];
  char *chybaotevreni[] = { " SOUBOR NELZE OTEVT\n", "        < OK >" };
  char *chybaodst[] = { " PLI MNOHO ODSTAVC\n", "         < OK >" };
  char *chybaodst2[] = { " NENALEZEN DN ODSTAVEC\n", "          < OK >" };
  char *chodst[] = { "         odstavec:\n", "    1 ", "2 ", "3 ", "4 ",
    "5 ", "6 ", "7 ", "8 ", "9 ", "10 ", "11 "
  };
  unsigned int znaku_odstavci[MAXODSTAVEC];
  unsigned int radku_odstavci[MAXODSTAVEC];
  int i;

  if (nov_text == NULL)
    {
#include "profi/spust-nov-text-c-file-manager.h"
#ifndef PSANIPROFI
      strncpy (jmeno_l, vyber_nov_text (), NAME_MAX);
      nov_text = jmeno_l;
#endif
    }
  else
    {
      strncpy (jmeno_l, nov_text, NAME_MAX);
    }
  if (nov_text == NULL || !strcmp (jmeno_l, ""))
    {
      print_hl (1, "Nebyl vybrn dn soubor");
      return 1;
    }

  if ((soubor_vt = fopen (jmeno_l, "rt")) == NULL)
    {
      if (global_get (g_warning) == g_w_ano)
	perror (jmeno_l);
      (void) button (chybaotevreni, 2, 1, 4, 24, LINES / 2 - 3,
		     COLS / 2 - 12);
      return 1;
    }
/**************************************************************************/
  for (i = 0; i < MAXODSTAVEC; i++)
    {
      znaku_odstavci[i] = 0;
      radku_odstavci[i] = 0;
    }

  odstavec->odstavcu = 0;
  odstavec->znaku = 0;
  odstavec->radku = 0;

  while (!nacti_radek
	 (radek_vt, sizeof (radek_vt) / sizeof (char), soubor_vt))
    {
      if (!strncmp (radek_vt, "#odstavec", 9)
	  || !strncmp (radek_vt, "#!odstavec", 10))
	{
	  (odstavec->odstavcu)++;
	}
      else if (!odstavec->odstavcu)
	{
	  (void) button (chybaodst2, 2, 1, 4, 28, LINES / 2 - 2,
			 COLS / 2 - 14);
	  return 1;
	}
      else if (strncmp (radek_vt, "#konec", 6))
	{
	  (odstavec->radku)++;
	  odstavec->znaku += secti_znaky (radek_vt);
	  radku_odstavci[odstavec->odstavcu - 1]++;
	  znaku_odstavci[odstavec->odstavcu - 1] += secti_znaky (radek_vt);
	}
      else
	break;
    }
/****************************************************************************/
  if (odstavec->odstavcu > MAXODSTAVEC)
    {
      button (chybaodst, 2, 1, 4, 25, LINES / 2 - 2, COLS / 2 - 12);
      return 1;
    }
  if (odstavec->odstavcu == 0)
    {
      button (chybaodst2, 2, 1, 4, 28, LINES / 2 - 2, COLS / 2 - 14);
      return 1;
    }
/*************************************************************************/
  odstavec->akt_odstavec =
    button (chodst, odstavec->odstavcu + 1, odstavec->odstavcu, 5, 30, 7, 12);

  if (odstavec->akt_odstavec <= 0)
    return 1;			/* chyba buttonu */

  odstavec->oradek = radku_odstavci[odstavec->akt_odstavec - 1];
  odstavec->oznaku = znaku_odstavci[odstavec->akt_odstavec - 1];


/* nastaveni aktualniho odstavce */
  if (fseek (soubor_vt, 0, SEEK_SET))
    {
      if (global_get (g_warning) == g_w_ano)
	perror ("fseek");
      return 1;
    }

  i = 0;

  while (!nacti_radek
	 (radek_vt, sizeof (radek_vt) / sizeof (char), soubor_vt))
    {
      if (!strncmp (radek_vt, "#odstavec", 9)
	  || !strncmp (radek_vt, "#!odstavec", 10))
	i++;
      if (i == odstavec->akt_odstavec)
	{
	  if (!strncmp (radek_vt, "#!", 2))
	    odstavec->mezernik = 0;
	  else
	    odstavec->mezernik = 1;
	  break;
	}
    }

  return 0;
}

/**********************************/
/**********************************/


int
spust_nov_text (type_uziv * slozka, type_nastaveni * nastaveni,
		type_odstavec * odstavec)
{
  unsigned int znak, radku, chyb, cas;
  int ch;

  odstavec->lekce = 0;
  /* odstavec->mezernik = slozka->vtext.mezernik; */
  obnov_nadpis2 (slozka, nastaveni, odstavec);
  znak = radku = chyb = cas = 0;

  vymaz_okno (sub_psani);
  obnov_radek1
    ("Po zmknut <mezernku> b as a do ukonen odstavce", -1,
     znak, radku, chyb, cas, odstavec->mezernik /*slozka->vtext.mezernik */ );
  print_hl (1,
	    "Psan odstartujete zmknutm <mezernku>, ukonte <BACKSPACE>");
  obnov_psani ();
  tiskni_dle_priority ();

  ch = '\0';
#include "profi/spust-nov-text-c-zobraz-odstavec.h"
  while (ch != ' ')
    {
      if ((ch == KEY_BACKSPACE) || (ch == 'k'))
	{
	  global_set (g_run, g_run_null);
	  return 1;
	}
      ch = getch3 ();
    }

  global_set (g_run, g_run_vt);

  while (!nacti_radek
	 (radek_vt, sizeof (radek_vt) / sizeof (char), soubor_vt))
    {
      if (!strncmp (radek_vt, "#odstavec", 9)
	  || !(strncmp (radek_vt, "#!odstavec", 10))
	  || !strncmp (radek_vt, "#konec", 6))
	break;
      else
	{
	  radku++;
	  if (pis_radek
	      (&cas, radek_vt, radku, &znak, &chyb, odstavec->mezernik,
	       (boolean) nastaveni->vtext.test))
	    {
	      tiskni_dle_priority ();
	      global_set (g_run, g_run_null);
	      return 1;
	    }
	}
    }

  if (fclose (soubor_vt) && (global_get (g_warning) == g_w_ano))
    perror ("fclose");
  global_set (g_run, g_run_null);
  odstavec->oznaku = znak;
  obnov_psani ();
  tiskni_dle_priority ();

  vyhodnot_nov_text (nastaveni, odstavec,
		     znamka_nov_lekce (nastaveni->vtext, odstavec->oznaku,
				       chyb, cas));
  return 0;
}
